Index: main.sym
===================================================================
--- main.sym	(revision 1604)
+++ main.sym	(revision 1605)
@@ -23,10 +23,6 @@
 00000000 a __tmp_reg__
 00000000 a __tmp_reg__
 00000000 a __tmp_reg__
-00000000 a __tmp_reg__
-00000000 a __tmp_reg__
-00000000 a __tmp_reg__
-00000000 a __tmp_reg__
 00000000 W __vector_default
 00000000 T __vectors
 00000001 a __zero_reg__
@@ -53,10 +49,6 @@
 00000001 a __zero_reg__
 00000001 a __zero_reg__
 00000001 a __zero_reg__
-00000001 a __zero_reg__
-00000001 a __zero_reg__
-00000001 a __zero_reg__
-00000001 a __zero_reg__
 00000034 a __CCP__
 00000034 a __CCP__
 00000034 a __CCP__
@@ -81,10 +73,6 @@
 00000034 a __CCP__
 00000034 a __CCP__
 00000034 a __CCP__
-00000034 a __CCP__
-00000034 a __CCP__
-00000034 a __CCP__
-00000034 a __CCP__
 0000003d a __SP_L__
 0000003d a __SP_L__
 0000003d a __SP_L__
@@ -109,10 +97,6 @@
 0000003d a __SP_L__
 0000003d a __SP_L__
 0000003d a __SP_L__
-0000003d a __SP_L__
-0000003d a __SP_L__
-0000003d a __SP_L__
-0000003d a __SP_L__
 0000003e a __SP_H__
 0000003e a __SP_H__
 0000003e a __SP_H__
@@ -137,10 +121,6 @@
 0000003e a __SP_H__
 0000003e a __SP_H__
 0000003e a __SP_H__
-0000003e a __SP_H__
-0000003e a __SP_H__
-0000003e a __SP_H__
-0000003e a __SP_H__
 0000003f a __SREG__
 0000003f a __SREG__
 0000003f a __SREG__
@@ -165,10 +145,6 @@
 0000003f a __SREG__
 0000003f a __SREG__
 0000003f a __SREG__
-0000003f a __SREG__
-0000003f a __SREG__
-0000003f a __SREG__
-0000003f a __SREG__
 0000008c T __ctors_end
 0000008c T __ctors_start
 0000008c T __dtors_end
@@ -214,286 +190,277 @@
 00000106 T wl_register_packet_group
 0000012c T wl_unregister_packet_group
 00000168 T wl_do
-000002c4 t wl_send_packet
-00000354 T wl_send_pan_packet
-00000372 T wl_send_global_packet
-00000392 T wl_send_robot_to_robot_packet
-000003ac T wl_send_robot_to_robot_global_packet
-000003c8 T wl_get_xbee_id
-000003ce T wl_get_channel
-000003d4 T wl_set_channel
-000003da T wl_get_pan
-000003e0 T wl_set_pan
-000003e6 T wl_terminate
-00000416 T wl_init
-0000044a T wl_token_ring_leave
-00000458 T wl_token_ring_set_bom_functions
-00000472 t wl_token_ring_cleanup
-00000474 t wl_token_ring_response_handler
-00000476 T wl_token_iterator_has_next
-00000490 T wl_token_get_matrix_size
-00000496 T wl_token_get_num_robots
-0000049c T wl_token_get_robots_in_ring
-000004a2 T wl_token_iterator_next
-00000522 T wl_token_iterator_begin
-0000055e T wl_token_is_robot_in_ring
-00000564 T wl_token_get_sensor_reading
-000005aa T wl_token_get_my_sensor_reading
-000005c0 t default_get_bom
-000005e6 T wl_token_ring_unregister
-000005f0 T wl_token_ring_join
-00000630 t wl_token_pass_token
-00000796 t wl_token_ring_receive_handler
-00000b7c t wl_token_ring_timeout_handler
-00000c80 T wl_token_ring_register
-00000cb2 T __vector_30
-00000d1c T xbee_get_packet
-00000f80 T xbee_get_pan_id
-00000f8a T xbee_get_channel
-00000f94 T xbee_get_address
-00000fa0 t xbee_send_modify_at_command
-000010b4 T xbee_set_channel
-000010f8 T xbee_set_pan_id
+00000252 t wl_send_packet
+000002e2 T wl_send_pan_packet
+00000300 T wl_send_global_packet
+00000320 T wl_send_robot_to_robot_packet
+0000033a T wl_send_robot_to_robot_global_packet
+00000356 T wl_get_xbee_id
+0000035c T wl_get_channel
+00000362 T wl_set_channel
+00000368 T wl_get_pan
+0000036e T wl_set_pan
+00000374 T wl_terminate
+000003a4 T wl_init
+000003d8 T wl_token_ring_leave
+000003e6 T wl_token_ring_set_bom_functions
+00000400 t wl_token_ring_cleanup
+00000402 t wl_token_ring_response_handler
+00000404 T wl_token_iterator_has_next
+0000041e T wl_token_get_matrix_size
+00000424 T wl_token_get_num_robots
+0000042a T wl_token_get_robots_in_ring
+00000430 T wl_token_iterator_next
+000004b0 T wl_token_iterator_begin
+000004ec T wl_token_is_robot_in_ring
+000004f2 T wl_token_get_sensor_reading
+00000538 T wl_token_get_my_sensor_reading
+0000054e t default_get_bom
+00000574 T wl_token_ring_unregister
+0000057e T wl_token_ring_join
+000005be t wl_token_pass_token
+00000724 t wl_token_ring_receive_handler
+00000bce t wl_token_ring_timeout_handler
+00000cd2 T wl_token_ring_register
+00000d04 T __vector_30
+00000d6e T xbee_get_packet
+00000fd2 T xbee_get_pan_id
+00000fdc T xbee_get_channel
+00000fe6 T xbee_get_address
+00000ff2 t xbee_send_modify_at_command
 000010ff W __stack
-0000112c T xbee_reset
-0000115c T xbee_terminate
-0000116a T xbee_send_packet
-0000126e t xbee_send_string
-000012ba T xbee_lib_init
-00001444 T sensor_matrix_create
-00001486 T sensor_matrix_set_reading
-000014b8 T sensor_matrix_get_reading
-000014e6 T sensor_matrix_set_in_ring
-0000153a T sensor_matrix_get_in_ring
-00001556 T sensor_matrix_get_joined
-00001560 T sensor_matrix_get_size
-00001566 T bom_get
-00001576 T bom_get_max
-000015ae T bom_get_max10
-00001a40 T bom_off
-00001a6a T bom_on
-00001a94 T bom_set_leds
-00001af0 T bom_init
-00001b8c T bom_refresh
-00001ca8 T get_max_bom
-00001ce8 T digital_input
-00001e2a T digital_pull_up
-00001f14 T digital_output
-0000214c T button1_read
-00002172 T button1_click
-000021b8 T button2_read
-000021e2 T button2_click
-00002228 T button2_wait
-00002250 T button1_wait
-00002278 T flash_red
-000022d8 T dragonfly_init
-00002364 T eeprom_put_byte
-00002378 T eeprom_get_byte
-0000238e T get_robotid
-000023ca T get_bom_type
-0000241a T encoder_read
-0000243e T encoder_get_x
-00002462 T encoder_get_dx
-00002486 T encoder_rst_dx
-000024a2 T encoder_get_tc
-000024ac T encoder_rst_tc
-000024be T encoder_wait
-000024d8 T encoder_recv
-00002790 T left_data_at
-000027ae T right_data_at
-000027cc T get_dx
-00002894 T encoder_get_v
-000028ea T encoders_init
-0000295e T encoder_recv_complete
-0000297c T lcd_clear_screen
-000029a6 T lcd_putc
-000029e4 T lcd_puts
-00002a2e T lcd_gotoxy
-00002a46 T lcd_puti
-00002b2a T lcd_putbyte
-00002b32 T lcd_init
-00002b9c T __vector_16
-00002c76 T __vector_15
-00002d0c t apply_orbs
-0000302e T orb_n_set
-0000306a T orb1_set
-0000309a T orb2_set
-000030ca T orb_set
-00003106 T orbs_set
-0000314a T orb_n_set_color
-000031a6 T orb1_set_color
-000031f4 T orb2_set_color
-00003242 T orb_set_color
-00003290 T orbs_set_color
-00003348 T orb_enable_timer
-00003354 T orb_disable_timer
-0000335c T orb_set_mode
-00003386 T orb_init_binary
-000033a4 T orb_init_pwm
-000033c2 T orb_init
-000033c8 T motors_init
-000033ec T motor_l_set
-0000341c T motor_r_set
-0000344c T motor1_set
-00003452 T motor2_set
-00003458 T motors_off
-0000345e T linearize_distance
-00003482 T range_read_distance
-000034aa T range_init
-000034b8 T usb_init
-000034d4 T xbee_init
-000034fe T usb_putc
-0000350a T xbee_putc
-0000351e T usb_puts
-00003536 T usb_getc
-00003540 T xbee_getc
-00003550 T usb_getc_nb
-00003568 T xbee_getc_nb
-00003586 T usb_puti
-00003624 T hex_digit
-00003638 T usb_puth16
-00003696 T usb_puth8
-000036c0 T usb_puts_P
-0000370a T spi_init
-00003732 T spi_transfer
-0000373e T __vector_17
-000037c6 T delay_ms
-000037dc T rtc_init
-0000381c T rtc_get
-00003828 T rtc_reset
-00003832 T __vector_26
-000038ce T analog_init
-00003940 T analog8
-00003964 T analog10
-00003986 T analog_start_loop
-000039a4 T analog_stop_loop
-000039b2 T analog_loop_status
-000039be T analog_get8
-00003a06 T analog_get10
-00003a6a T wheel
-00003a72 T set_adc_mux
-00003a94 T __vector_21
-00003bfc T buzzer_init
-00003bfe T buzzer_set_val
-00003c08 T buzzer_set_freq
-00003c3c T buzzer_off
-00003c46 T buzzer_chirp
-00003c66 T __ashldi3
-00003d64 T __divdi3
-00004db4 T __moddi3
-00005e2e t do_rand
-00005eca T rand_r
-00005ed0 T rand
-00005eda T srand
-00005ef0 T memcpy_P
-00005f02 T printf
-00005f2c T vfprintf
-000062e6 T strnlen_P
-000062fc T strnlen
-00006312 T fputc
-0000636a T __ultoa_invert
-00006426 T __divmodhi4
-00006426 T _div
-0000643a t __divmodhi4_neg2
-00006440 t __divmodhi4_exit
-00006442 t __divmodhi4_neg1
-0000644c T __divmodsi4
-00006460 t __divmodsi4_neg2
-0000646e t __divmodsi4_exit
-00006470 t __divmodsi4_neg1
-00006482 T __mulsi3
-000064c0 T __udivmodhi4
-000064c8 t __udivmodhi4_loop
-000064d6 t __udivmodhi4_ep
-000064e8 T __udivmodsi4
-000064f4 t __udivmodsi4_loop
-0000650e t __udivmodsi4_ep
-0000652c T __prologue_saves__
-00006564 T __epilogue_restores__
-0000659a T _exit
-0000659a W exit
-0000659c t __stop_program
-0000659e A __data_load_start
-0000659e T _etext
-00006a0a A __data_load_end
+00001106 T xbee_set_channel
+0000114a T xbee_set_pan_id
+0000117e T xbee_reset
+000011ae T xbee_terminate
+000011bc T xbee_send_packet
+000012c0 t xbee_send_string
+0000130c T xbee_lib_init
+00001496 T sensor_matrix_create
+000014d8 T sensor_matrix_set_reading
+0000150a T sensor_matrix_get_reading
+00001538 T sensor_matrix_set_in_ring
+0000158c T sensor_matrix_get_in_ring
+000015a8 T sensor_matrix_get_joined
+000015b2 T sensor_matrix_get_size
+000015b8 T bom_get
+000015c8 T bom_get_max
+00001600 T bom_get_max10
+00001a92 T bom_off
+00001abc T bom_on
+00001ae6 T bom_set_leds
+00001b42 T bom_init
+00001bde T bom_refresh
+00001cfa T get_max_bom
+00001d3a T digital_input
+00001e7c T digital_pull_up
+00001f66 T digital_output
+0000219e T button1_read
+000021c4 T button1_click
+0000220a T button2_read
+00002234 T button2_click
+0000227a T button2_wait
+000022a2 T button1_wait
+000022ca T flash_red
+0000232a T dragonfly_init
+000023b6 T eeprom_put_byte
+000023ca T eeprom_get_byte
+000023e0 T get_robotid
+0000241c T get_bom_type
+0000246c T encoder_read
+00002490 T encoder_get_x
+000024b4 T encoder_get_dx
+000024d8 T encoder_rst_dx
+000024f4 T encoder_get_tc
+000024fe T encoder_rst_tc
+00002510 T encoder_wait
+0000252a T encoder_recv
+000027e2 T left_data_at
+00002800 T right_data_at
+0000281e T get_dx
+000028e6 T encoder_get_v
+0000293c T encoders_init
+000029b0 T encoder_recv_complete
+000029ce T lcd_clear_screen
+000029f8 T lcd_putc
+00002a36 T lcd_puts
+00002a80 T lcd_gotoxy
+00002a98 T lcd_puti
+00002b7c T lcd_putbyte
+00002b84 T lcd_init
+00002bee T __vector_16
+00002cc8 T __vector_15
+00002d5e t apply_orbs
+00003080 T orb_n_set
+000030bc T orb1_set
+000030ec T orb2_set
+0000311c T orb_set
+00003158 T orbs_set
+0000319c T orb_n_set_color
+000031f8 T orb1_set_color
+00003246 T orb2_set_color
+00003294 T orb_set_color
+000032e2 T orbs_set_color
+0000339a T orb_enable_timer
+000033a6 T orb_disable_timer
+000033ae T orb_set_mode
+000033d8 T orb_init_binary
+000033f6 T orb_init_pwm
+00003414 T orb_init
+0000341a T motors_init
+0000343e T motor_l_set
+0000346e T motor_r_set
+0000349e T motor1_set
+000034a4 T motor2_set
+000034aa T motors_off
+000034b0 T linearize_distance
+000034d4 T range_read_distance
+000034fc T range_init
+0000350a T usb_init
+00003526 T xbee_init
+00003550 T usb_putc
+0000355c T xbee_putc
+00003570 T usb_puts
+00003588 T usb_getc
+00003592 T xbee_getc
+000035a2 T usb_getc_nb
+000035ba T xbee_getc_nb
+000035d8 T usb_puti
+00003676 T hex_digit
+0000368a T usb_puth16
+000036e8 T usb_puth8
+00003712 T usb_puts_P
+0000375c T spi_init
+00003784 T spi_transfer
+00003790 T __vector_17
+00003818 T delay_ms
+0000382e T rtc_init
+0000386e T rtc_get
+0000387a T rtc_reset
+00003884 T __vector_26
+00003920 T analog_init
+00003992 T analog8
+000039b6 T analog10
+000039d8 T analog_start_loop
+000039f6 T analog_stop_loop
+00003a04 T analog_loop_status
+00003a10 T analog_get8
+00003a58 T analog_get10
+00003abc T wheel
+00003ac4 T set_adc_mux
+00003ae6 T __vector_21
+00003c4e T buzzer_init
+00003c50 T buzzer_set_val
+00003c5a T buzzer_set_freq
+00003c8e T buzzer_off
+00003c98 T buzzer_chirp
+00003cb8 T __ashldi3
+00003db6 T __divdi3
+00004e06 T __moddi3
+00005e80 t do_rand
+00005f1c T rand_r
+00005f22 T rand
+00005f2c T srand
+00005f42 T memcpy_P
+00005f54 T __divmodhi4
+00005f54 T _div
+00005f68 t __divmodhi4_neg2
+00005f6e t __divmodhi4_exit
+00005f70 t __divmodhi4_neg1
+00005f7a T __divmodsi4
+00005f8e t __divmodsi4_neg2
+00005f9c t __divmodsi4_exit
+00005f9e t __divmodsi4_neg1
+00005fb0 T __mulsi3
+00005fee T __udivmodhi4
+00005ff6 t __udivmodhi4_loop
+00006004 t __udivmodhi4_ep
+00006016 T __udivmodsi4
+00006022 t __udivmodsi4_loop
+0000603c t __udivmodsi4_ep
+0000605a T __prologue_saves__
+00006092 T __epilogue_restores__
+000060c8 T _exit
+000060c8 W exit
+000060ca t __stop_program
+000060cc A __data_load_start
+000060cc T _etext
+00006528 A __data_load_end
 00800100 D __data_start
-0080011d d bom_on_function
-0080011f d bom_off_function
-00800121 d get_max_bom_function
-00800123 d wl_token_ring_handler
-0080012d d wl_token_next_robot
-0080012f d deathDelay
-00800131 d joinDelay
-00800133 d accepted
-00800135 d acceptor
-00800163 d xbee_panID
-00800165 d xbee_pending_panID
-00800167 d lookup
-00800177 d C.1.1327
-0080017d d FontLookup
-0080035d D orb_mask
-00800363 D enable_orb_pwm
-00800364 D pwm_read_buffer
-00800366 D pwm_write_buffer
-00800368 D pwm_free_buffer
-0080036a d IR_dist_conversion
-0080045f d C.1.1625
-00800465 d _rtc_scale
-00800467 D __clz_tab
-00800567 d next
-0080056c B __bss_start
-0080056c D __data_end
-0080056c D _edata
-0080056c b wl_timeout
-0080056e b wl_buf
-008005ee b wl_packet_groups
-0080060e b iteratorCount
-00800610 b bom_on_count
-00800612 b ringState
-00800614 B buffer_last
-00800616 B buffer_first
-00800618 b xbee_address
-0080061a b xbee_channel
-0080061c b xbee_pending_channel
-0080061e b currentBufPos
-00800620 b xbee_buf
-0080068c b bom_type
-0080068d b bom_val
-008006ad b select_pins
-008006b5 b analog_pin
-008006b7 B pwm_page_flip
-008006b8 B current_pwm_channel
-008006b9 B orb_lock
-008006ba b spi_bytes
-008006bb b spi_recv_func
-008006bd b spi_recv_complete_func
-008006bf b _rtc_pulse
-008006c1 b _rtc_val
-008006c3 b _rtc_f
-008006c5 B adc_loop_status
-008006c7 B adc_sig_stop_loop
-008006c9 B adc_current_port
-008006cb B arrival_buf
-0080074b B m
-0080095d B data_ready
-0080095f B right_data
-00800961 B left_data_buf
-00800963 B left_data_array
-008009bf B left_data_idx
-008009c1 B right_dx
-008009c3 B timecount
-008009c7 B encoder_buf_index
-008009c8 B right_data_array
-00800a24 B left_dx
-00800a26 B right_data_idx
-00800a28 B right_data_buf
-00800a2a B left_data
-00800a2c B pwm_buffer
-00800a53 B orb_values
-00800a59 B usb_fd
-00800a5b B xbee_fd
-00800a5d B an_val
-00800a7e B __iob
-00800a84 B __bss_end
-00800a84 N _end
+0080010e d bom_on_function
+00800110 d bom_off_function
+00800112 d get_max_bom_function
+00800114 d wl_token_ring_handler
+0080011e d wl_token_next_robot
+00800120 d deathDelay
+00800122 d joinDelay
+00800124 d accepted
+00800126 d acceptor
+00800154 d xbee_panID
+00800156 d xbee_pending_panID
+00800158 d lookup
+00800168 d C.1.1327
+0080016e d FontLookup
+0080034e D orb_mask
+00800354 D enable_orb_pwm
+00800355 D pwm_read_buffer
+00800357 D pwm_write_buffer
+00800359 D pwm_free_buffer
+0080035b d IR_dist_conversion
+00800450 d C.1.1467
+00800456 d _rtc_scale
+00800458 D __clz_tab
+00800558 d next
+0080055c B __bss_start
+0080055c D __data_end
+0080055c D _edata
+0080055c b wl_timeout
+0080055e b wl_buf
+008005de b wl_packet_groups
+008005fe b iteratorCount
+00800600 b bom_on_count
+00800602 b ringState
+00800604 B buffer_last
+00800606 B buffer_first
+00800608 b xbee_address
+0080060a b xbee_channel
+0080060c b xbee_pending_channel
+0080060e b currentBufPos
+00800610 b xbee_buf
+0080067c b bom_type
+0080067d b bom_val
+0080069d b select_pins
+008006a5 b analog_pin
+008006a7 B pwm_page_flip
+008006a8 B current_pwm_channel
+008006a9 B orb_lock
+008006aa b spi_bytes
+008006ab b spi_recv_func
+008006ad b spi_recv_complete_func
+008006af b _rtc_pulse
+008006b1 b _rtc_val
+008006b3 b _rtc_f
+008006b5 B adc_loop_status
+008006b7 B adc_sig_stop_loop
+008006b9 B adc_current_port
+008006bb B arrival_buf
+0080073b B m
+0080094d B data_ready
+0080094f B right_data
+00800951 B left_data_buf
+00800953 B left_data_array
+008009af B left_data_idx
+008009b1 B right_dx
+008009b3 B timecount
+008009b7 B encoder_buf_index
+008009b8 B right_data_array
+00800a14 B left_dx
+00800a16 B right_data_idx
+00800a18 B right_data_buf
+00800a1a B left_data
+00800a1c B pwm_buffer
+00800a43 B orb_values
+00800a49 B an_val
+00800a6a B __bss_end
+00800a6a N _end
 00810000 N __eeprom_end