Index: wireless.lst
===================================================================
--- wireless.lst	(.../john/projects/libwireless/lib/wireless.lst)	(revision 1693)
+++ wireless.lst	(.../hunter_prey_john/projects/libwireless/lib/wireless.lst)	(revision 1694)
@@ -482,30 +482,30 @@
  514               	/* File "wireless.c": code  369 = 0x0171 ( 279), prologues  39, epilogues  51 */
 DEFINED SYMBOLS
                             *ABS*:00000000 wireless.c
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:3      *ABS*:0000003f __SREG__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:4      *ABS*:0000003e __SP_H__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:5      *ABS*:0000003d __SP_L__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:6      *ABS*:00000000 __tmp_reg__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:7      *ABS*:00000001 __zero_reg__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:12     .text:00000000 timer_handler
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:3      *ABS*:0000003f __SREG__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:4      *ABS*:0000003e __SP_H__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:5      *ABS*:0000003d __SP_L__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:6      *ABS*:00000000 __tmp_reg__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:7      *ABS*:00000001 __zero_reg__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:12     .text:00000000 timer_handler
                              .bss:00000000 wl_timeout
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:26     .text:0000000e wl_register_packet_group
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:512    .bss:00000082 wl_packet_groups
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:56     .text:00000034 wl_unregister_packet_group
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:96     .text:00000070 wl_do
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:511    .bss:00000002 wl_buf
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:216    .text:0000015c wl_send_packet
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:299    .text:000001ec wl_send_pan_packet
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:322    .text:0000020a wl_send_global_packet
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:346    .text:0000022a wl_send_robot_to_robot_packet
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:367    .text:00000244 wl_send_robot_to_robot_global_packet
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:389    .text:00000260 wl_get_xbee_id
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:400    .text:00000266 wl_get_channel
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:411    .text:0000026c wl_set_channel
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:422    .text:00000272 wl_get_pan
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:433    .text:00000278 wl_set_pan
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:444    .text:0000027e wl_terminate
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccV6KufF.s:478    .text:000002ae wl_init
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:26     .text:0000000e wl_register_packet_group
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:512    .bss:00000082 wl_packet_groups
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:56     .text:00000034 wl_unregister_packet_group
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:96     .text:00000070 wl_do
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:511    .bss:00000002 wl_buf
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:216    .text:0000015c wl_send_packet
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:299    .text:000001ec wl_send_pan_packet
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:322    .text:0000020a wl_send_global_packet
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:346    .text:0000022a wl_send_robot_to_robot_packet
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:367    .text:00000244 wl_send_robot_to_robot_global_packet
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:389    .text:00000260 wl_get_xbee_id
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:400    .text:00000266 wl_get_channel
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:411    .text:0000026c wl_set_channel
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:422    .text:00000272 wl_get_pan
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:433    .text:00000278 wl_set_pan
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:444    .text:0000027e wl_terminate
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccu8lDFd.s:478    .text:000002ae wl_init
 
 UNDEFINED SYMBOLS
 __do_copy_data