Index: wl_token_ring.lst
===================================================================
--- wl_token_ring.lst	(.../john/projects/libwireless/lib/wl_token_ring.lst)	(revision 1693)
+++ wl_token_ring.lst	(.../hunter_prey_john/projects/libwireless/lib/wl_token_ring.lst)	(revision 1694)
@@ -1033,42 +1033,42 @@
  1089               	/* File "wl_token_ring.c": code 1035 = 0x040b ( 939), prologues  40, epilogues  56 */
 DEFINED SYMBOLS
                             *ABS*:00000000 wl_token_ring.c
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:3      *ABS*:0000003f __SREG__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:4      *ABS*:0000003e __SP_H__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:5      *ABS*:0000003d __SP_L__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:6      *ABS*:00000000 __tmp_reg__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:7      *ABS*:00000001 __zero_reg__
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:13     .text:00000000 wl_token_ring_leave
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1071   .bss:00000004 ringState
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:27     .text:0000000e wl_token_ring_set_bom_functions
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1049   .data:00000000 bom_on_function
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1053   .data:00000002 bom_off_function
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1057   .data:00000004 get_max_bom_function
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:42     .text:00000028 wl_token_ring_cleanup
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:51     .text:0000002a wl_token_ring_response_handler
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:61     .text:0000002c wl_token_iterator_has_next
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:3      *ABS*:0000003f __SREG__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:4      *ABS*:0000003e __SP_H__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:5      *ABS*:0000003d __SP_L__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:6      *ABS*:00000000 __tmp_reg__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:7      *ABS*:00000001 __zero_reg__
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:13     .text:00000000 wl_token_ring_leave
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1071   .bss:00000004 ringState
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:27     .text:0000000e wl_token_ring_set_bom_functions
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1049   .data:00000000 bom_on_function
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1053   .data:00000002 bom_off_function
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1057   .data:00000004 get_max_bom_function
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:42     .text:00000028 wl_token_ring_cleanup
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:51     .text:0000002a wl_token_ring_response_handler
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:61     .text:0000002c wl_token_iterator_has_next
                              .bss:00000000 iteratorCount
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:82     .text:00000046 wl_token_get_matrix_size
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:93     .text:0000004c wl_token_get_num_robots
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:104    .text:00000052 wl_token_get_robots_in_ring
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:115    .text:00000058 wl_token_iterator_next
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:173    .text:000000d8 wl_token_iterator_begin
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:211    .text:00000114 wl_token_is_robot_in_ring
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:222    .text:0000011a wl_token_get_sensor_reading
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:263    .text:0000015c wl_token_get_my_sensor_reading
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:281    .text:00000172 wl_token_ring_unregister
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1061   .data:00000006 wl_token_ring_handler
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:294    .text:0000017c wl_token_ring_join
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1079   .data:00000014 joinDelay
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:330    .text:000001ba wl_token_pass_token
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1083   .data:00000016 accepted
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1069   .data:00000010 wl_token_next_robot
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1075   .data:00000012 deathDelay
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:502    .text:00000318 wl_token_ring_receive_handler
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1045   .bss:00000002 bom_on_count
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1087   .data:00000018 acceptor
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:915    .text:000006d0 wl_token_ring_timeout_handler
-F:\DOCUME~1\Evan\LOCALS~1\Temp/ccv7YxBR.s:1017   .text:000007d4 wl_token_ring_register
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:82     .text:00000046 wl_token_get_matrix_size
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:93     .text:0000004c wl_token_get_num_robots
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:104    .text:00000052 wl_token_get_robots_in_ring
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:115    .text:00000058 wl_token_iterator_next
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:173    .text:000000d8 wl_token_iterator_begin
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:211    .text:00000114 wl_token_is_robot_in_ring
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:222    .text:0000011a wl_token_get_sensor_reading
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:263    .text:0000015c wl_token_get_my_sensor_reading
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:281    .text:00000172 wl_token_ring_unregister
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1061   .data:00000006 wl_token_ring_handler
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:294    .text:0000017c wl_token_ring_join
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1079   .data:00000014 joinDelay
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:330    .text:000001ba wl_token_pass_token
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1083   .data:00000016 accepted
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1069   .data:00000010 wl_token_next_robot
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1075   .data:00000012 deathDelay
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:502    .text:00000318 wl_token_ring_receive_handler
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1045   .bss:00000002 bom_on_count
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1087   .data:00000018 acceptor
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:915    .text:000006d0 wl_token_ring_timeout_handler
+F:\DOCUME~1\Evan\LOCALS~1\Temp/ccyQFxcu.s:1017   .text:000007d4 wl_token_ring_register
 
 UNDEFINED SYMBOLS
 __do_copy_data